# Health-Skill by *meow*
#
# Version 1.0


# Imports

# ES-Imports
import es

# RPG-Imports
from meowrpg import playerlist, config



# Script
skillname = 'Health'


# Load config values
rpgHealthValue = config.GetInt('rpgHealthValue') 


# Events
def load():
    es.loadevents('declare', 'addons/eventscripts/rpg/Includes/rpg_events.res')
    es.loadevents('addons/eventscripts/rpg/Includes/rpg_events.res') 


def unload():
    for i in playerlist.GetPlayerlist():
        try:
            del i.properties['maxHealth']
        except:
            pass
        
        
def es_map_start(ev):
    es.loadevents('addons/eventscripts/rpg/Includes/rpg_events.res') 


def rpg_player_spawn(ev):
    # Get player and his maximal health
    player = playerlist[ev['userid']]
    maxHealth = 100 + player.GetSkillLevel(skillname) * rpgHealthValue
    
    # Set the player's "maxhealth" property (used by medic, regeneration and shop)   
    player.properties['maxhealth'] = maxHealth 
    player.player.setHealth(maxHealth)
    

def rpg_skill_level_changed(ev):
    if ev['skill'] == skillname:
        playerlist[ev['userid']].properties['maxhealth'] += (int(ev['level']) - int(ev['old_level'])) * rpgHealthValue